(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.d3TooltipBox = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(_dereq_,module,exports){
'use strict';

var _tooltip = _dereq_('./src/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _config = _dereq_('./src/config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Notes:
 * 1) module.exports is used instead of ES6 export, because Babel
 * will create a d3Tooltip.default object, which is not convenient
 * for browser usage.
 *
 * 2) derequire is used so that it can be bundled with browserify again
 * see:
 *  http://stackoverflow.com/a/28176927
 *  https://github.com/substack/node-browserify/issues/374
 *  https://github.com/substack/node-browserify/pull/1151
 */
module.exports = {
  tooltip: _tooltip2.default,
  config: _config.configurationSetter
};

},{"./src/config":2,"./src/tooltip":3}],2:[function(_dereq_,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.configurationSetter = configurationSetter;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TooltipConfig = function () {
    function TooltipConfig() {
        _classCallCheck(this, TooltipConfig);

        this._DEFAULT_CONFIG = {
            template: "<div>@{value}</div>"
        };
        this._config = this._DEFAULT_CONFIG;
    }

    _createClass(TooltipConfig, [{
        key: "configuration",
        value: function configuration(v) {
            if (arguments.length == 0) {
                return this._config;
            }

            this._config = Object.assign({}, this._DEFAULT_CONFIG, v);
            return this;
        }
    }, {
        key: "template",
        value: function template(v) {
            if (arguments.length == 0) {
                return this._config.template;
            }

            this._config.template = v;
            return this;
        }
    }]);

    return TooltipConfig;
}();

var configuration = exports.configuration = new TooltipConfig();

function configurationSetter(v) {
    console.warn('The usage of the global configuration API is in beta and could be removed, please use it with caution');
    configuration.configuration(v);
}

},{}],3:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = tooltip;

var _config = _dereq_('./config');

var _utils = _dereq_('./utils');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * D3 tooltip plugin
 * Inspired by on http://bl.ocks.org/mbostock/1087001
 */

var Tooltip = function () {
    function Tooltip() {
        _classCallCheck(this, Tooltip);

        // Constants
        this._DEFAULT_POSITION_OFFSET = { left: 0, top: 0 };

        // Variables
        this._tooltipClass = 'd3-tooltip-box';
        this._transitionSpeed = 200;
        this._parent = d3.select('body');
        this._dataAccessor = function (d) {
            return d.value;
        };
        this._template = _config.configuration.template();
        this._positionOffset = this._DEFAULT_POSITION_OFFSET;
    }

    /**
     * Initializes the tooltip container, if there is already
     * a container, reuses the same tooltip, otherwise creates
     * a new <div> container
     * @returns {d3.selection} tooltip container
     * @private
     */


    _createClass(Tooltip, [{
        key: '_initTooltip',
        value: function _initTooltip() {
            var tooltipEl = d3.select('.' + this._tooltipClass);
            if (tooltipEl.empty()) {
                tooltipEl = this._createTooltip();
            }
            return tooltipEl;
        }

        /**
         * Creates a new <div> as the container of the tooltip
         * @returns {d3.selection} new tooltip container 
         * @private
         */

    }, {
        key: '_createTooltip',
        value: function _createTooltip() {
            return this.parent().append('div').attr('class', this._tooltipClass).style({
                opacity: 0,
                position: 'absolute',
                'pointer-events': 'none'
            });
        }

        /**
         * Gets the content of the tooltip by either
         * compiling a static template or invoking the
         * function of a dynamic template
         * @param d the associated data
         * @returns {ELEMENT_NODE} content of the tooltip as HTML
         * @private
         */

    }, {
        key: '_getContent',
        value: function _getContent(d) {
            var template = this._template;
            if ((0, _utils.isFunction)(template)) {
                return template(d);
            } else {
                var data = this._dataAccessor(d);
                return (0, _utils.compileTemplate)(template, data);
            }
        }

        /**
         * Parent getter/setter
         * @param v the parent to set
         * @returns {d3.selection} the current parent (returned only if
         * invoked with no parameters)
         */

    }, {
        key: 'parent',
        value: function parent(v) {
            if (arguments.length == 0) {
                return this._parent;
            }

            if (!(0, _utils.isD3Selection)(v)) {
                v = d3.select(v);
            }
            this._parent = v;
            return this;
        }

        /**
         * Position offset getter/setter, the offset must
         * be in the shape of {left: 0, top: 0}
         * @param v the offset to set
         * @returns {Object} current offset (returned only if invoked with
         * not parameters)
         */

    }, {
        key: 'positionOffset',
        value: function positionOffset(v) {
            if (arguments.length == 0) {
                return this._positionOffset;
            }

            this._positionOffset = Object.assign({}, this._DEFAULT_POSITION_OFFSET, v);
            return this;
        }

        /**
         * Data accessor getter/setter
         * @param v the accessor function to set
         * @returns {Function} the current accessor function (returned only if
         * invoked with no parameters)
         */

    }, {
        key: 'data',
        value: function data(v) {
            if (arguments.length == 0) {
                return this._dataAccessor;
            }

            this._dataAccessor = v;
            return this;
        }

        /**
         * Template getter/setter
         * @param v the template to set, if string it is considered
         * static template, if function it is considered dynamic template
         * and will be invoked with the associated data as parameter
         * @returns {*} the current template string or factory function
         * (returned only if invoked with no parameters)
         */

    }, {
        key: 'template',
        value: function template(v) {
            if (arguments.length == 0) {
                return this._template;
            }

            this._template = v;
            return this;
        }

        /**
         * Makes the tooltip visible
         * @param d the associated data of the selection
         */

    }, {
        key: 'show',
        value: function show(d) {
            if (!this._tooltipEl) {
                this._tooltipEl = this._initTooltip();
            }

            var html = this._getContent(d);

            this._tooltipEl.html(html);

            this._tooltipEl.transition(this._transitionSpeed).style("opacity", 1);
        }

        /**
         * Moves the tooltip to the mouse position
         */

    }, {
        key: 'move',
        value: function move() {
            var clientRect = this._tooltipEl.node().getBoundingClientRect();

            this._tooltipEl.style({
                left: (0, _utils.formatPx)(d3.event.pageX + this._positionOffset.left),
                top: (0, _utils.formatPx)(d3.event.pageY - clientRect.height + this._positionOffset.top)
            });
        }

        /**
         * Hides the tooltip
         */

    }, {
        key: 'hide',
        value: function hide() {
            this._tooltipEl.transition(this._transitionSpeed).style('opacity', 0);
        }

        /**
         * Attaches the tooltip event listeners to
         * the current selection
         * @returns {Function} function to be used for the
         * d3.selection.call method
         */

    }, {
        key: 'bind',
        value: function bind() {
            var self = this;

            return function (selection) {
                selection.each(function (data) {
                    var element = d3.select(this);

                    element.on('mouseover.d3-tooltip-box', function (d) {
                        self.show(d);
                    }).on('mousemove.d3-tooltip-box', function () {
                        self.move();
                    }).on('mouseleave.d3-tooltip-box', function () {
                        self.hide();
                    });
                });
            };
        }
    }]);

    return Tooltip;
}();

/**
 * Tooltip factory, creates new instances of the tooltip
 * @returns {Tooltip} the new tooltip instance
 */


function tooltip() {
    var instance = new Tooltip();
    return instance;
}

},{"./config":2,"./utils":4}],4:[function(_dereq_,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.formatPx = formatPx;
exports.compileTemplate = compileTemplate;
exports.isFunction = isFunction;
exports.isD3Selection = isD3Selection;
/**
 * Attaches the 'px' suffix to a number
 * @param value the value to be formatted
 * @returns {string} the numeric value with the 'px' attached
 */
function formatPx(value) {
    return value + 'px';
}

/**
 * Compiles a template by replacing the properties in the form
 * of ${propertyName} by the corresponding value provided in the
 * data object
 * @param template the raw template to compile
 * @param data the data containing the values to be used to replace
 * the placeholders
 * @returns {String} the compiled template
 */
function compileTemplate(template, data) {
    for (var prop in data) {
        var regex = new RegExp('\\@\\{' + prop + '\\}', 'gi');
        template = template.replace(regex, data[prop]);
    }

    return template;
}

/**
 * Tests if an object is a function
 * @param obj object to test
 * @returns {boolean} true if the object is a function,
 * false otherwise
 */
function isFunction(obj) {
    return typeof obj === 'function';
}

/**
 * Tests if the object is a D3 selection
 * @param obj object to test
 * @returns {boolean} true if the object is a D3 selection,
 * false otherwise
 */
function isD3Selection(obj) {
    return obj instanceof d3.selection;
}

},{}]},{},[1])(1)
});